#include <wchar.h>

//#include "stdafx.h"
#include "Module.h"

#define __CYGWIN__
#define USEIMPORTLIB

#include "ruby.h"
#include "ruby_molip.h"

#if defined(__cplusplus)
extern "C" {
#endif

#define DefineConst(func, v) rb_define_const(mRoot, #v, func(v))

VALUE mRoot, mMain;
static VALUE cObj, cRect, cRichText, cTextEditor, cDocument, sLayerZOrder;

VALUE sLayerZOrder_alloc(FCLayerZOrder *x)
{
	return rb_struct_new(sLayerZOrder,
		INT2NUM(x->dwLayerIdx),
		INT2NUM(x->dwZOrder),
		0 );
}

void sLayerZOrder_get_struct(VALUE obj, FCLayerZOrder *x)
{
	if (!rb_obj_is_kind_of(obj, sLayerZOrder))
		rb_raise(rb_eTypeError, "%s is not a %s",
			RSTRING(rb_inspect(obj))->ptr,
			rb_class2name(sLayerZOrder));
	x->dwLayerIdx = NUM2INT(RSTRUCT(obj)->ptr[0]);
	x->dwZOrder = NUM2INT(RSTRUCT(obj)->ptr[1]);
}

void sLayerZOrder_setup()
{
	sLayerZOrder = rb_struct_define("LayerZOrder",
		"LayerIdx",
		"ZOrder",
		0 );

	rb_global_variable(&sLayerZOrder);
}

#define BUF_LEN	64

VALUE mMain_RegisterCommand(VALUE self, VALUE menu_p, VALUE menu, VALUE shortcut)
{
	char *str;
	int len;
	wchar_t wcs[BUF_LEN];
	str = rb_str2cstr(menu, &len);
	if (len > BUF_LEN-1) {
		return Qnil;
	}
	setlocale(LC_ALL, "Japanese");
	len = mbstowcs(wcs, str, sizeof wcs);
	wcs[len] = L'\0';
	return rb_uint2inum(FMpgGetMolipMain()->RegisterCommand(RTEST(menu_p), wcs, NUM2CHR(shortcut)));
}

VALUE mMain_GetZoom(VALUE self)
{
	return rb_float_new(FMpgGetMolipMain()->GetZoom());
}

VALUE mMain_SetZoom(VALUE self, VALUE v)
{
	FMpgGetMolipMain()->SetZoom(rb_num2dbl(v));
	return v;
}

VALUE mMain_CreateObject(VALUE self, VALUE v)
{
	FCObjectExp* pObj = FMpgGetMolipMain()->CreateObject((FTObjectType)NUM2INT(v));
	return Data_Wrap_Struct(cObj, NULL, NULL, pObj);
}

VALUE mMain_GetTextEditor(VALUE self)
{
	FCTextEditorWrp* pEditor = FMpgGetMolipMain()->GetTextEditorWrp();
	return Data_Wrap_Struct(cTextEditor, NULL, NULL, pEditor);
}

VALUE mMain_GetDocument(VALUE self)
{
	FCDocumentWrp* pDocument = FMpgGetMolipMain()->GetDocumentWrp();
	return Data_Wrap_Struct(cDocument, NULL, NULL, pDocument);
}

VALUE cRect_new(VALUE self, VALUE left, VALUE top, VALUE right, VALUE bottom)
{
	DBLRect* mmrtNew = &DBLRect(NUM2DBL(left), NUM2DBL(left), NUM2DBL(left), NUM2DBL(left));
	return Data_Wrap_Struct(self, NULL, NULL, mmrtNew);
}
/*
VALUE cTextEditor_GetCurIndex(VALUE self)
{
	FCTextEditorExp* pEditor;
	Data_Get_Struct(self, FCTextEditorExp, pEditor);
	return pEditor->GetCurIndex();
}
*/
VALUE cTextEditor_OnChar(VALUE self, VALUE v)
{
	FCTextEditorWrp* pEditor;
	Data_Get_Struct(self, FCTextEditorWrp, pEditor);
	pEditor->OnChar(CHR2FIX(v));
	return self;
}

VALUE cDocument_SessionBegin(VALUE self)
{
	FCDocumentWrp* pDocument;
	Data_Get_Struct(self, FCDocumentWrp, pDocument);
	pDocument->SessionBegin();
	return self;
}

VALUE cDocument_SessionEnd(VALUE self)
{
	FCDocumentWrp* pDocument;
	Data_Get_Struct(self, FCDocumentWrp, pDocument);
	pDocument->SessionEnd();
	return self;
}

VALUE cDocument_Session(VALUE self, VALUE v)
{
	cDocument_SessionBegin(self);
    return rb_ensure(RETULONG(rb_yield), self, RETULONG(cDocument_SessionEnd), self);
}

VALUE cDocument_CmdCreate1Obj(VALUE self, VALUE obj, VALUE lzo)
{
	FCDocumentWrp* pDocument;
	FCObjBase* pObj;
	FCLayerZOrder lzorder;
	Data_Get_Struct(self, FCDocumentWrp, pDocument);
	Data_Get_Struct(obj, FCObjBase, pObj);
	sLayerZOrder_get_struct(lzo, &lzorder);
	pDocument->CmdCreate1Obj(pObj, lzorder);
	cDocument_SessionBegin(self);
	return self;
}

VALUE cObj_CalcResizeFrame(VALUE self)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	pObj->CalcResizeFrame();
	return self;
}

VALUE cObj_CalcOuterFrame(VALUE self)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	pObj->CalcOuterFrame();
	return self;
}

VALUE cObj_ExportTextAll(VALUE self)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	return pObj->ExportTextAll() ? Qtrue : Qfalse;
}

VALUE cObj_ImportTextAll(VALUE self)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	return pObj->ImportTextAll() ? Qtrue : Qfalse;
}

VALUE cObj_SetPenBack(VALUE self, VALUE v)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	pObj->SetPenBackSColor(NUM2INT(v));
	return v;
}

VALUE cObj_SetBrushBack(VALUE self, VALUE v)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	pObj->SetBrushBackSColor(NUM2INT(v));
	return v;
}

VALUE cObj_Resize(VALUE self, VALUE xposi, VALUE yposi, VALUE rect)
{
	FCObjectExp* pObj;
	BOOL bXPosi, bYPosi;
	DBLRect* mmrtNew;
	Data_Get_Struct(self, FCObjectExp, pObj);
	bXPosi = RTEST(xposi);
	bYPosi = RTEST(yposi);
	Data_Get_Struct(rect, DBLRect, mmrtNew);
	pObj->Resize(bXPosi, bYPosi, *mmrtNew);
	return self;
}

VALUE cObj_CreateRichText(VALUE self)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	FCRichText* pText = pObj->CreateRichText();
	return Data_Wrap_Struct(cRichText, NULL, NULL, pText);
}

VALUE cObj_GetRichText(VALUE self)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	FCRichText* pText = pObj->GetRichText();
	if (pText == NULL)
		return Qnil;
	else
		return Data_Wrap_Struct(cRichText, NULL, NULL, pText);
}

VALUE cObj_SetRichText(VALUE self, VALUE text)
{
	FCObjectExp* pObj;
	Data_Get_Struct(self, FCObjectExp, pObj);
	FCRichText* pText;
	Data_Get_Struct(text, FCRichText, pText);
	pText = pObj->SetRichText(pText);
	if (pText == NULL)
		return Qnil;
	else
		return Data_Wrap_Struct(cRichText, NULL, NULL, pText);
}

void Init_MolipRuby()
{
	mRoot = rb_define_module("Molip");

	DefineConst(INT2FIX, FDOJ_NONE);
	DefineConst(INT2FIX, FDOJ_OBJECT);
	DefineConst(INT2FIX, FDOJ_FIGURE);
	DefineConst(INT2FIX, FDOJ_LINE);
	DefineConst(INT2FIX, FDOJ_RECT);
	DefineConst(INT2FIX, FDOJ_ROUND_RECT);
	DefineConst(INT2FIX, FDOJ_ARC);
	DefineConst(INT2FIX, FDOJ_POLY);
	DefineConst(INT2FIX, FDOJ_GROUP);
	DefineConst(INT2FIX, FDOJ_WIDE_POLY);
	DefineConst(INT2FIX, FDOJ_OLE);
	DefineConst(INT2FIX, FDOJ_CHIP_MASTER);
	DefineConst(INT2FIX, FDOJ_POINT);
	DefineConst(INT2FIX, FDOJ_PICT_ARROW);
	DefineConst(INT2FIX, FDOJ_LABEL);

	DefineConst(INT2FIX, FD_S_COLOR_WHITE);
	DefineConst(INT2FIX, FD_S_COLOR_BLACK);
	DefineConst(INT2FIX, FD_S_COLOR_TRANSPARENT);

	sLayerZOrder_setup();

	mMain = rb_define_module_under(mRoot, "Main");
	if (FMpgGetMolipMain()) {
	//	DefineModuleAttrGet(mMain, zoom);
	//	DefineModuleAttrSet(mMain, zoom);
		rb_define_module_function(mMain, "RegisterCommand", RETVALUE(mMain_RegisterCommand), 3);
		rb_define_module_function(mMain, "GetZoom", RETVALUE(mMain_GetZoom), 0);
		rb_define_module_function(mMain, "SetZoom", RETVALUE(mMain_SetZoom), 1);
		rb_define_module_function(mMain, "CreateObject", RETVALUE(mMain_CreateObject), 1);
		rb_define_module_function(mMain, "GetTextEditor", RETVALUE(mMain_GetTextEditor), 0);
		rb_define_module_function(mMain, "GetDocument", RETVALUE(mMain_GetDocument), 0);
	}

	cRect = rb_define_class_under(mRoot, "Rect", rb_cObject);
	rb_define_singleton_method(cRect, "new", RETVALUE(cRect_new), 4);

	cRichText = rb_define_class_under(mRoot, "RichText", rb_cObject);

	cTextEditor = rb_define_class_under(mRoot, "TextEditor", rb_cObject);
//	rb_define_method(cTextEditor, "GetCurIndex", RETVAL(cTextEditor_GetCurIndex), 0);
	rb_define_method(cTextEditor, "OnChar", RETVALUE(cTextEditor_OnChar), 1);

	cDocument = rb_define_class_under(mRoot, "Document", rb_cObject);
	rb_define_method(cDocument, "Session", RETVALUE(cDocument_Session), 0);

	cObj = rb_define_class_under(mRoot, "Object", rb_cObject);
	rb_define_method(cObj, "CalcResizeFrame", RETVALUE(cObj_CalcResizeFrame), 0);
	rb_define_method(cObj, "CalcOuterFrame", RETVALUE(cObj_CalcOuterFrame), 0);
	rb_define_method(cObj, "ExportTextAll", RETVALUE(cObj_ExportTextAll), 0);
	rb_define_method(cObj, "ImportTextAll", RETVALUE(cObj_ImportTextAll), 0);
	rb_define_method(cObj, "SetPenBack", RETVALUE(cObj_SetPenBack), 1);
	rb_define_method(cObj, "SetBrushBack", RETVALUE(cObj_SetBrushBack), 1);
	rb_define_method(cObj, "Resize", RETVALUE(cObj_Resize), 3);
	rb_define_method(cObj, "CreateRichText", RETVALUE(cObj_CreateRichText), 0);
	rb_define_method(cObj, "GetRichText", RETVALUE(cObj_GetRichText), 0);
	rb_define_method(cObj, "SetRichText", RETVALUE(cObj_SetRichText), 1);
}

#if defined(__cplusplus)
}
#endif
